var player = false;
var transfer = false;
var inactivityTimer = 0;
var manager = false;
var conditional = false;
var logger_visible = false;

var geo_watch_id = false;

var status_bar_timer = false;
var service_timer = false;


var mouse_click_start_time = 0;

document.addEventListener('deviceready', function(){
    window.plugins.insomnia.keepAwake();
    $(document).ready(function(){
      try{
        if(!player){
            player = new PlayerController();
            $(player).on("PlayerDataLoaded",onPlayerDataLoaded);
            player.init();
        }        
      }catch(e){
        console.log("Unable to start player");
        try{
          if(player.platform == "ANDROID"){
              cordova.plugins.backgroundMode.enable();
          }
        }catch(e){
          console.log("Unable to start backgroundMode");
        }
        try{
          if(!transfer){
              transfer = new TransferService();
              transfer.init(player.version);
              transfer.setLogger(player.logger);
          }
          transfer.update(player.timestamp);
          transfer.activateLogger(player.debug);
        }catch(e){
          console.log("Unable to start transfer");
        }
        try{
          schedule = player.config.getScheduleConfig();
        }catch(e){
          console.log("No Schedule !");
        }
        try{
          if(!manager){
              manager = new ManagerService();
              manager.init();
              manager.setLogger(player.logger);
              try{
                transfer.onUpdatedManagerInterval = function(interval){
                  console.log("Checking ManagerService Interval");
                  manager.checkInterval(interval);
                };
              }catch(e){
                console.log("Could not check interval for management");
              }
          }
          manager.update(schedule);
          manager.activateLogger(player.debug);
          
        }catch(e){
          console.log("Unable to start manager");
        }
      }
    });
}, false);


function status_bar_hide(){
  clearTimeout(status_bar_hide);
  player.log("Hide Status Bar ...");
  StatusBar.hide();
  status_bar_timer = setTimeout(status_bar_hide,3000);
}

function onPlayerDataLoaded(){
    if(!service_timer){
        service_timer = setInterval(service,10000);
    }
    try{
      if(player.platform == "ANDROID"){
          cordova.plugins.backgroundMode.enable();
      }
    }catch(e){
      console.log("Unable to start backgroundMode");
    }
    try{
      if(!transfer){
          transfer = new TransferService();
          transfer.init(player.version);
          transfer.setLogger(player.logger);
      }
      transfer.update(player.timestamp);
      transfer.activateLogger(player.debug);
    }catch(e){
      console.log("Unable to start transfer");
    }
    try{
      schedule = player.config.getScheduleConfig();
    }catch(e){
      console.log("No Schedule !");
    }
    try{
      if(!manager){
          manager = new ManagerService();
          manager.init();
          manager.setLogger(player.logger);
          try{
            transfer.onUpdatedManagerInterval = function(interval){
              console.log("Checking ManagerService Interval");
              manager.checkInterval(interval);
            };
          }catch(e){
            console.log("Could not check interval for management");
          }
      }
      manager.update(schedule);
      manager.activateLogger(player.debug);
    }catch(e){
      console.log("Unable to start manager");
    }

    //Kiosk.setKioskEnabled(player.config.getAlwaysOnTop());
    try{
      if(player.playlist.conditional){
          if(!conditional){
              conditional = new ConditionalService();
              conditional.init(player.playlist.conditional.onNewConditionValue);
          }
          conditional.update(player.playlist.conditional.types);

          // Condition Agents Activate
          //activateConditionalAgents(true);
      }else{
          if(conditional){
              conditional.unload();
              conditional = null;
              conditional = false;
          }
          // Condition Agents Deactivate
          //activateConditionalAgents(false);
      }
    }catch(e){
      console.log("Unable to start conditional service");
    }

}

function service(){
    if(player){
      player.service();
      try{
        if(transfer){
            transfer.updateInfo(player.name,player.getInfo());
        }
      }catch(e){
        console.log("Unable to update player info for transfer");
      }
    }
}

window.addEventListener("touchstart", onTouchScreenStart, false);
window.addEventListener("mousedown", onTouchScreenStart, false);


function onTouchScreenStart(event) {
    //console.log("Start MultiTouch : "+event.targetTouches.length);
    mouse_click_start_time = new Date().getTime();
}

window.addEventListener("touchend", onTouchScreenEnd, false);
window.addEventListener("mouseup", onTouchScreenEnd, false);

function onTouchScreenEnd(event) {
    //console.log("End MultiTouch : "+event.targetTouches.length);
    //navigator.app.exitApp();
    var mousedown_time = new Date().getTime() - mouse_click_start_time;
    if(mousedown_time > 5000){
      //player.OS.force_screensaver_mode(5);
      /*
      if(typeof(player.config) !== "undefined"){
        if(player.config.getQuitOnClick()){
          player.OS.quit(true,true);
        }
      }
      */
      player.OS.quit(true,true);
    }else{
      if(typeof(player.config) !== "undefined"){
        if(player.registered){
          if(player.config.getQuitOnClick()){
              player.OS.quit();
          }
        }
      }
    }

    if(typeof(event.targetTouches) != "undefined"){
      if (event.targetTouches.length >= 3) {
        /*
          logger_visible = !logger_visible;
          player.setLogger(player.log_window);
          player.activateLogger(logger_visible);
          transfer.setLogger(player.log_window);
          transfer.activateLogger(logger_visible);
          manager.setLogger(player.log_window);
          manager.activateLogger(logger_visible);
          */
          if(!player.core_setup_window_showing && !player.proxy_setup_window_showing){
            player.toggleCoreSetupWindow();
          }else{
            if(player.core_setup_window_showing){
              player.toggleCoreSetupWindow();
            }
            player.toggleProxySetupWindow();
          }
      }
    }
}

function activateConditionalAgents(activate){
    if(activate){
        //GEO
        if(!geo_watch_id){
            geo_watch_id = navigator.geolocation.watchPosition(onGeoUpdate, onGeoError, { timeout: 15000, enableHighAccuracy: true });
        }
        //SCREEN ORIENTATION
        window.addEventListener("orientationchange",onScreenOrientationChange);

    }else{
        navigator.geolocation.clearWatch(geo_watch_id);
        window.removeEventListener("orientationchange",onScreenOrientationChange);
    }
}

function onScreenOrientationChange(){
    console.log(screen.orientation);
    var timestamp = parseInt(new Date().getTime()/1000);
    var screen_orientation = {
        'id': 34,
        'filename': "screen_orientation.xml",
        'mdate': 0,
        'tstamp': timestamp,
        'version': "1.0",
        'status': "ok",
        'value': screen.orientation.type
    };
    conditional.writeConditionFile(screen_orientation);
}

function onGeoUpdate(position){
    var latitude = position.coords.latitude;
    var longitude = position.coords.longitude;
    var altitude = position.coords.altitude;
    var accuracy = position.coords.accuracy;
    var altitudeAccuracy = position.coords.altitudeAccuracy;
    var heading = position.coords.heading;

    if(conditional){
        var timestamp = parseInt(new Date().getTime()/1000);

        // Write latitude Condition
        var lat = {
            'id': 1,
            'filename': "lat.xml",
            'mdate': 0,
            'tstamp': timestamp,
            'version': "1.0",
            'status': "ok",
            'value': latitude
        };
        conditional.writeConditionFile(lat);

        // Write longitude Condition
        var lon = {
            'id': 2,
            'filename': "lon.xml",
            'mdate': 0,
            'tstamp': timestamp,
            'version': "1.0",
            'status': "ok",
            'value': longitude
        };
        conditional.writeConditionFile(lon);

        // Write heading Condition
        var head = {
            'id': 20,
            'filename': "heading.xml",
            'mdate': 0,
            'tstamp': timestamp,
            'version': "1.0",
            'status': "ok",
            'value': heading
        };
        conditional.writeConditionFile(head);

        // TODOs:
        // cordova-plugin-device-motion : accelerometer
        // cordova-plugin-device-orientation : screen orientation
    }
}

function onGeoError(event){
    console.log("GEO Error ... could not get position");
}
